package queuetest;

public class QueueL {

    private Node head;
    private int size;
//--------------------------------------------------------------

    public QueueL() // constructor
    {
        head = null;
        size = 0;
    }
//--------------------------------------------------------------

    public void enqueue(Object j) // put item on head of qeue
    {
        //add to head of linked list
        size++;
        Node nN;
        if (head == null) {
            nN = new Node(j, null);
        } else {
            nN = new Node(j, head);
        }
        head = nN;
    }
//--------------------------------------------------------------

    public Object dequeue() // take item from end of qeue
    {
        //remove from linked list
        if (size>0)
            size--;
        if (head == null) // size=0
        {
            return null;
        } else if (head.next == null) { //size=1
            Object t = head.data;
            head = null;
            return t;
        }
        Node current=head;
        Node temp=null;
        while (current.next!=null){
            temp=current;
            current=current.next;
        }
        temp.next=null;
        return current.data;
    }
//--------------------------------------------------------------

    public Object peek() // peek at end of qeue
    {
        Node current=head;
        for(;current.next!=null;current=current.next);
        return current.data;
    }
//--------------------------------------------------------------

    public boolean isEmpty() // true if qeue is empty
    {
        return (head == null);
    }
///--------------------------------------------------------------

    public int size() // true if qeue is empty
    {
        return size;
    }

    public void display() // display qeue content
    {
        Node temp = head;
        int i=1;
        while (temp != null) {
            System.out.println(i+":"+ temp.data);
            temp = temp.next;
            i++;
        }
    }

}
